#include <stdio.h>
#include <stdlib.h>

int COUNT   = 80000;
int ACTIVE  = 1000000000;
int MAXSIZE = 4000;
int MINSIZE = 400;
int MIN_UNIT = 1 ;

typedef
struct mem_list {
	void *address;
	int size;
	struct mem_list *next;
} MEM_LIST, *MEM_LIST_PTR;


void
print_mem_list(MEM_LIST_PTR m)
{
    MEM_LIST_PTR n;
    if (!m) return;
    n = m->next;
    for(;n&&n!=m;n=n->next) {
	if (n->address)
	    printf("0x%08x 0x%08x\n",n->address,n->size);
    }
}

void
die(char *msg)
{
    fprintf(stderr,"%s\n",msg);
    exit(0);
}

int
option(int ac, char *av[])
{
    int i = 1;
    while(ac>1) {
	if (av[i][0] == '-') {
	    switch (av[i][1]) {
	    case 'c': COUNT = atoi(av[++i]); break;
	    case 'a': ACTIVE = atoi(av[++i]); break;
	    case 'u': MIN_UNIT = atoi(av[++i]); break;
	    case 'm': MAXSIZE = atoi(av[++i]); break;
	    case 'l': MINSIZE = atoi(av[++i]); break;
	    }
	}
	ac--; i++;
    }
}

int
main(int ac, char *av[])
{
    MEM_LIST mlist;
    MEM_LIST_PTR last = &mlist;
    MEM_LIST_PTR new;
    int i,size;

    option(ac,av);

    mlist.address = NULL;
    mlist.size = 0;
    for(i=0;i<ACTIVE;i++) {
	new = (MEM_LIST_PTR)malloc(sizeof(MEM_LIST)); 
	if (!new) die("malloc error");
	new->address = NULL;
	new->next = NULL;
	last->next = new;
	last = new;
    }
    last->next = &mlist;

    for(i=0;i++<COUNT;last=last->next) {
	size = ((random()%(MAXSIZE-MINSIZE))+MINSIZE)*MIN_UNIT;
	if (last->address) {
	    free(last->address);
	}
	last->size = size;
	last->address = (void *)malloc(size);
	if (!last->address) die("malloc error");
    }
    print_mem_list(&mlist);
}
