#!/usr/bin/perl 
require 5.002;
use strict;
BEGIN { $ENV{PATH} = '/usr/ucb:/bin' }
use Socket;
use Carp;

sub logmsg { print "$0 $$: @_ at ", scalar localtime, "\n" }

my $port = shift || 2345;
my $proto = getprotobyname('tcp');
$port = $1 if $port =~ /(\d+)/; # untaint port number

socket(Server, PF_INET, SOCK_STREAM, $proto)        || die "socket: $!";
setsockopt(Server, SOL_SOCKET, SO_REUSEADDR,
				 pack("l", 1))   || die "setsockopt: $!";
bind(Server, sockaddr_in($port, INADDR_ANY))        || die "bind: $!";
listen(Server,SOMAXCONN)                            || die "listen: $!"
;

logmsg "server started on port $port";

my $paddr;
my $pid;

# $SIG{CHLD} = \&REAPER;

while(1) {
    $paddr = accept(Client,Server);
    my($port,$iaddr) = sockaddr_in($paddr);
    my $name = gethostbyaddr($iaddr,AF_INET);
    my $flag = 0;

    select(Client); $|=1;
    select(STDOUT); $|=1;

    print "login <$name [",inet_ntoa($iaddr),"]>\n";

    unless(defined ($pid = fork())) {
	die "cannot fork: $!";
    } elsif($pid == 0) {
	while(1) {
	    print "> ";
	    my $line = <>;
	    print Client $line;
	}
	exit;
    } else {
	while(<Client>) {
	    chomp($_);
	    if("" eq $_) {}
	    else {
		print "\n$name: $_\n \n> ";
	    }
	}
	waitpid($pid,0);
    }
    print "logout <$name [",inet_ntoa($iaddr),"]>\n";
}
close Client;
exit;