/*
    OS Scheduler Simulator

** Ϣ衧 ΰؾ󹩳ز    
** E-Mail Address: kono@ie.u-ryukyu.ac.jp
**
**    ΥΤʤʣ̡ѡޤ
**    κݤˤϡï׸򼨤ʬĤȡ
**    ۤ仨Ͽʤɤ䤤碌ɬפޤ
**    Ѥ嵭ȿʤϰϤǵĤޤ
**    Хʥۤκݤˤversion message¸뤳ȤȤޤ
**    ΥץˤĤƤä˲ݾڤ⤷ʤ餺
**
**    Everyone is permitted to do anything on this program 
**    including copying, modifying, improving,
**    as long as you don't try to pretend that you wrote it.
**    i.e., the above copyright notice has to appear in all copies.  
**    Binary distribution requires original version messages.
**    You don't have to ask before copying, redistribution or publishing.
**    THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE.

   Queue based scheduler

 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "queue.h"
#include "task.h"

static void run(QueuePtr task);
void fifo(QueuePtr task);
void sjf(QueuePtr task);
void pri(QueuePtr task);
void rr(QueuePtr task);

static char buf[BUFSIZ];

static int quantum = 80;

/*
   ɸϤͿ줿Υǡɤ߹ߡ
   task queue ơ run Ǽ¹Ԥ롣

    # type[n/p] clock taskname task-size priority [period]
    n 0 a 110 5

    n non-periodic
    p periodic
 */
int
main()
{
    int time; char name[BUFSIZ]; int length; int priority;
    QueuePtr task_list = NULL;
    QueuePtr q;
    char *name1;
    char type;

    init_queue(100);

    task_count = 0;
    while(fgets(buf,BUFSIZ,stdin)!=NULL) {
	if (buf[0]=='#') continue;
	if (buf[0]!='n') continue;
	sscanf(buf,"%c %d %s %d %d",&type,&time,name,&length,&priority);
	if ((name1=malloc(strlen(name)))==0) {
	    die("Can't allocate name\n");
	}
	strcpy(name1,name);
	q = new_queue(name1, length, priority);
	if (!q) {
	    die("Can't allocate queue\n");
	}
	task_list = append_queue(task_list,q);
	task_count++;
    }
    run(task_list);
    report();
    return 0;
}

static void
run(QueuePtr task)
{
    //fifo(task);
    //sjf(task);
	//pri(task);
	rr(task);
}


/*
    First in First Out Ǽ¹Ԥ
 */

void
fifo(QueuePtr task)
{
    QueuePtr q;
    while(task) {
	task = dequeue(task,&q);
	exec_task(q,quantum);
    }
}

/*
   task  sort Ѥδؿ
 */

static 
int by_length(QueuePtr q,QueuePtr r)
{
    return q->length > r->length;
}

static 
int by_priority(QueuePtr q,QueuePtr r)
{
	return q->priority > r->priority;
}

/*
    Shoftest Job First Ǽ¹Ԥ
 */

void
sjf(QueuePtr task)
{
    QueuePtr q;
    task  = sort_queue(task,by_length);
    while(task) {
	task = dequeue(task,&q);
	exec_task(q,quantum);
    }
}

/*
    Priority Scheduling Ǽ¹Ԥ
*/

void
pri(QueuePtr task)
{
    QueuePtr q;
    task  = sort_queue(task,by_priority);
    while(task) {
	task = dequeue(task,&q);
	exec_task(q,quantum);
    }
}


/*
    Round-Robin Scheduling Ǽ¹Ԥ
*/

static int prev = 0;

void
rr(QueuePtr task)
{
	// ƵΥե饰
	int r_flag = 1;
	QueuePtr q,task_save;
	task = sort_queue(task,by_priority);
	
	while(r_flag == 1){
		r_flag = 0;
		task_save = task;
		
		while(task) {
			task = dequeue(task,&q);
		
		// ˽λץ¹ԤʤȽ̽
			if(q->length){
				prev += exec_task(q,quantum);
				
				if(q->length){ 
				  q->prev_end = prev;
				}
				
			}
		}
		
		task = task_save;
		 
		while(task){
			task = dequeue(task,&q);
			// λƤʤץ뤫ɤĴ٤
			
			if(q->length > 0){
				task = task_save;
				r_flag = 1;
				break;
			}
		}
	}
}

/* end */
