#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <pwd.h>
#include <time.h>

int
main( int argc,char *argv[] ) 
{
  if( argc != 2 )
    {
      fprintf( stderr,"Usage:%% %s filename ?n",argv[0] );
      exit( 1 );
    }
  ls_l( argv[1] );/* ϥե */
  printf("?n");
}

int
ls_l( char *path ) 
{
  struct stat buf;
  struct tm *ltime;
  char *mon[] = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
  char line[256];
  char m_print[]={"rwxrwxrwx"};
  int mode[] = {0000400,0000200,0000100,0000040,0000020,0000010,0000004,0000002,0000001};
  int i, j,flag = 0;
  
  if ( lstat ( path,&buf ) == -1 ) {
    perror( path );
    exit(1);
  }
  switch ( buf.st_mode & S_IFMT ) {
  case S_IFREG:
    printf("-");
    break;
  case S_IFDIR:
    printf("d");
    break;
  case S_IFLNK: /* ܥå󥯤 */
    printf("l");
    flag = 1;
    break;
  default:
    printf(" ");
    break;
  }
  for(i = 0; i <= 8; i++) {
    if((buf.st_mode & mode[i]) != mode[i]){
      m_print[i]='-';
    } 
  }
  
  printf("%s",m_print);
  printf("   ");
  printf("%3d ",buf.st_nlink);
  uid_print(buf.st_uid);
  printf("%7d ",(int)buf.st_size);
  
  ltime = localtime(&buf.st_mtime);
  printf("%s ",mon[ltime->tm_mon]);
  printf("%2d ",ltime->tm_mday);
  printf("%2d:",ltime->tm_hour);
  printf("%2d ",ltime->tm_min);
  printf("%s",path);
  if (flag == 1) {  /* ⤷ܥå󥯤ʤ */
    printf(" -> ");
    j = readlink(path, line, 256);
    line[j] = '\0';
    printf("%s \n",line);
  }
}


uid_print( uid_t uid )
{
  struct passwd *pwd ;
  pwd = getpwuid( uid );
  if( pwd == NULL )
    printf("%d    ",uid );
  else
    printf("%s    ", pwd->pw_name );
}