/*
	myls-l.c -- ls -l filename Ȥˤư򤹤ץ
	$Header: /home/h1/yas/slab-info1-os/4-file/RCS/myls-l.c,v 1.2 1995/06/08 08:23:45 yas Exp $
	Start: 1995/03/07 20:59:12
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <fcntl.h>  /* open(2) */
#include <sys/dirent.h>	/* getdirentries(2) */
#define BUFFSIZE        1024

main( argc,argv )
    int argc ;
    char *argv[] ;
{
	
	struct stat fir;
	int fd ;
	struct dirent *p ;
	char *buff ;
	int rcount ;
	long pointer;
	
	if( argc != 2 )
	{
	    fprintf( stderr,"Usage:%% %s filename \n",argv[0] );
	    exit( 1 );
	}
	
	if ( lstat ( argv[1],&fir ) == -1 ) {   /* ° */
		perror( argv[1] );
		exit(1);
	}
	
	if ( S_ISDIR(fir.st_mode) ) {   /* ⤷argv[1]ǥ쥯ȥʤ */
		fd = open( argv[1],O_RDONLY );  /* ɤ߹ */
		if( fd == -1 ) {
			perror( argv[1] );
			exit( 1 );
		}
		
		/* 
		Ǥϡmalloc() Ѥ BUFFSIZE ʬΥݤ롣
		*/
		buff = malloc( BUFFSIZE );
		if( buff == 0 ) {
			perror("memory");
			exit( 1 );
		}
		
		/* ǥ쥯ȥΥե̾ơls_l()פϤ */
		
		while((rcount=getdirentries(fd, buff, BUFFSIZE, &pointer))>0)  {
			for( p = (struct dirent *)buff ; (char *)p < &buff[rcount] ;
			p=(struct dirent *) ((int)p+(p->d_reclen)) ) {
				ls_l(p->d_name, argv[1]);
			}
		}
		close( fd );
		free( buff );
	}
	else {  /* argv[1]ǥ쥯ȥǤʤ */
		ls_l( argv[1],"./"); /* argv[1]ե̾ʤΤǥȥǥ쥯ȥϤ */
	}
	
}

ls_l( path ,dir)
    char *path ,*dir;
{
    struct stat buf;
	struct tm *ltime;
	char *mon[] = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
	char m_print[]={"rwxrwxrwx"}; /* st_modeѴ */
	int mode[] = {0000400,0000200,0000100,0000040,0000020,0000010,0000004,0000002,0000001}; /* st_modeѴ */
	int i,j;
	int flag = 0;
	char line[256];

	if ( lstat ( path,&buf ) == -1 ) { /* ե° */
		perror( path );
		exit(1);

	}
	
	chdir(dir); /* ꤷǥ쥯ȥ˥󥸥ǥ쥯ȥ */
	if ( lstat ( path,&buf ) == -1 ) {
		perror( path );
		exit(1);
	}
	
	/* ե */
	
	switch ( buf.st_mode & S_IFMT ) {

	  case S_IFLNK:
		printf("l");
		flag = 1;
		break;

	  case S_IFREG:
		printf("-");
		break;

	  case S_IFDIR:
		printf("d");
		break;

	  default:
		printf(" ");
		break;

	}

	for(i = 0; i <= 8; i++) { /* st_modeʸѴ */
		if((buf.st_mode & mode[i]) != mode[i]){
		m_print[i]='-';
			} 

	}

	

	printf("%s",m_print); /* ʸѴst_modeɽ */
	printf(" ");
	printf("%3d ",buf.st_nlink); /* 󥯿 */
	uid_print(buf.st_uid); /* եνͭ */
	printf("%7d ",(int)buf.st_size);  /* ե礭 */

	

	ltime = localtime(&buf.st_mtime); /* ֤ܻ֤Ѵ */
	printf("%s ",mon[ltime->tm_mon]); /* ѸɽѴ */
	printf("%2d ",ltime->tm_mday);  /*  */
	printf("%2d:",ltime->tm_hour);   /*  */
	printf("%2d ",ltime->tm_min);   /* ʬ */

	if (flag == 1){  /* ⤷ܥå󥯤ʤ */
                printf("%s",path);
                printf(" -> ");
                j = readlink(path, line, 256);
                line[j] = '\0';
                printf("%s \n",line);
	}

	else{
		printf("%s",path);
		printf("\n");
	}
}

/*
struct stat  st_uid եɤˤϡuid äƤ롣ͤȤ
ƤǤϤʤ̾Ȥɽ뤿ˤϡδؿ uid_print() 
ȤȤ褤ϡuid_t unsigned shortˤǤ롣
*/

uid_print( uid )
    uid_t uid ; /* unsigned short, in <sys/types.h > */
{
    struct passwd *pwd ;
	pwd = getpwuid( uid );
	if( pwd == NULL )
	    printf("%d ",uid );
    	else
	    printf("%s ", pwd->pw_name );
}
