#include <unistd.h>
#include <stdarg.h>

void exit(int status);
void perror(char *s);

int process_create_l(char *file, int ac, char *a, ...);

int
main(int argc , char *argv[])
{
  process_create_l("/bin/ls",2,"ls","-l",0);
  wait(0);
  process_create_l("/usr/bin/cal",3,"cal","12","2006",0 );
  wait(0);
  exit(0);
}

extern char **environ;

int
process_create_l( char *file,int av,char *aq,...)
{
  int child_pid ;
  if( (child_pid=fork()) == 0 )
    {
      char *argv[av];
      va_list ap;
      int i;

      va_start(ap,aq);
      argv[0] = aq;
      for(i=1; i < av; i++) {
	argv[i] = va_arg(ap, char *);
      }
      argv[av] = 0;
      va_end(ap);
          
      execve( file, argv, environ );
      perror( file );
      exit( 1 );
    }
  else
    {
      return( child_pid );
    }
}